#import "FlutterMolliePlugin.h"

@interface FlutterMolliePlugin ()
@property (nonatomic, strong) UIViewController *viewController;
@end

@implementation FlutterMolliePlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {

  FlutterMethodChannel* channel = [FlutterMethodChannel
                                       methodChannelWithName:@"fluttermollie"
                                       binaryMessenger:[registrar messenger]];

  UIViewController *viewController = [UIApplication sharedApplication].delegate.window.rootViewController;
  FlutterMolliePlugin *instance = [[FlutterMolliePlugin alloc] initWithViewController:viewController];
  [registrar addMethodCallDelegate:instance channel:channel];

}

- (instancetype)initWithViewController:(UIViewController *)viewController {
    self = [super init];

    if (self) {
        _viewController = viewController;
    }

    return self;
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {

    if ([@"startPayment" isEqualToString:call.method]) {

        NSString *checkoutUrl = call.arguments[@"checkoutUrl"];
        [[UIApplication sharedApplication] openURL:[NSURL URLWithString: checkoutUrl]];

    }
    else
    {
        result(FlutterMethodNotImplemented);
    }
}

@end
